#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N       6

void output_matrix(double [][N], int);
void mul_matrix(double [][N], double [][N], double [][N], int);
void inverse_matrix(double [][N], double [][N], int);

/*
int main(void)
{
  int n = 4;
  double A[N][N] = { {  2,  1,  2,  1},
                     {  1,  0,  2,  0},
                     {  3,  2,  6, -1},
                     {  4,  4,  3,  3} };
  double B[N][N];
  double C[N][N];

  printf("A = \n");
  output_matrix(A, n);
  putchar('\n');

  inverse_matrix(B, A, n);

  printf("A^(-1) = \n");
  output_matrix(B, n);
  putchar('\n');

  mul_matrix(C, B, A, n);

  printf("A^(-1) * A = \n");
  output_matrix(C, n);
  putchar('\n');
  
  return 0;
}
*/

/* 行列を出力する */
void output_matrix(double a[][N], int num)
{
  int i, j;

  for (i = 0; i < num; i++) {
    for(j = 0; j < num; j++){
      printf("%10f ", a[i][j]);
    }
    putchar('\n');
  }
}

/* 行列 a と b の積を c に代入する */
void mul_matrix(double c[][N], double a[][N], double b[][N], int num)
{
  int i, j, k;

  for (i = 0; i < num; i++) {
    for (j = 0; j < num; j++) {
      c[i][j] = 0.0;
      for (k = 0; k < num; k++) {
        c[i][j] += a[i][k] * b[k][j];
      }
    }
  }
}

/* 行列 a の逆行列を x に代入する */
void inverse_matrix(double x[][N], double a[][N], int n)
{
  int i, j, k;
  double sum, temp;

  double LU[N][N] = {};
  double y[N][N] = {};

  for (i = 0; i < n; i++) {
    LU[i][0] = a[i][0];
  }

  /* 上三角行列と下三角行列に分ける */
  for (i = 0; i < n; i++) {
    for (j = i + 1; j < n; j++) {
      sum = 0.0;
      for (k = 0; k < i; k++) {
	sum += LU[i][k] * LU[k][j];
      }
      LU[i][j] = (a[i][j] - sum) / LU[i][i];
    }
    for (j = i + 1; j < n; j++) {
      sum = 0.0;
      for (k = 0; k <= i; k++) {
	sum += LU[j][k] * LU[k][i + 1];
      }
      LU[j][i + 1] = a[j][i + 1] - sum;
    }
  }

  /* LY = I から、 Y の値を求める */
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      sum = 0.0;
      for (k = 0; k < i; k++) {
	sum += LU[i][k] * y[k][j];
      }
      if (i == j)
	temp = 1.0;
      else
	temp = 0.0;
      y[i][j] = (temp - sum) / LU[i][i];
    }
  }

  /* UX = Y から、X の値を求める */
  for (i = n - 1; i >= 0; i--) {
    for (j = n - 1; j >= 0; j--) {
      sum = 0.0;
      for (k = n - 1; k > i; k--) {
	sum += LU[i][k] * x[k][j];
      }
      x[i][j] = y[i][j] - sum;
    }
  }

}


